
       /////////////////////////////////////////////////////
      //                                                 //
     //      Wumpus.java                                //
    //     por Marlon G. Chermont(chermont@lsi.usp.br) //
   //    Criado: 20/08/2001							  //
  //    Ultima Alteracao: 22/11/2001                 //
 //                                                 //
/////////////////////////////////////////////////////


import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import java.applet.*;
import java.net.*;

import jeops.conflict.PriorityConflictSet;
import agentes.*;
import ambiente.Ambiente;
import ambiente.AmbienteInterface;

public class Wumpus extends Applet implements KeyListener,ActionListener,MouseListener,Runnable
{

   	static int NUMX = 5;
   	static int NUMY = 5;

    //parametros esteticos
    static float DOOR_SIZE_PCT = (float)0.46;
    static final Color BG_COLOR = Color.lightGray;

    static final int UP    = 0;
    static final int LEFT  = 1;
    static final int DOWN  = 2;
    static final int RIGHT = 3;
	
  

	AmbienteInterface amb;
	AgenteBase ag;

	AgenteMatadorRegras bc = new AgenteMatadorRegras();
	
	private Thread agenteThread = null;
	
    //Essas variaveis sao simplesmente para fazer um simples update da
    //figura em vz de pinta-la totalmente denovo
    boolean movemade=false;
    int last_x, last_y;

	boolean play=true;

    //Objeto de interface
    Panel worldpanel;
    Panel menupanel;
//	Panel texto;
	TextArea t1;
    PanelDePintura pp;
	TextField pontuacao;
	TextField limiteSuperior;
	CheckboxGroup perigo;
//	CheckboxGroup dificuldade;
	Button stop; 

	//Figuras
	Image wumpus;
	Image wumpusMorto;
	Image inter_verm;
	Image inter_verd;
	Image montanha;
	Image pegadas;
	Image moedas;
	Image flechaU;
	Image flechaL;
	Image flechaD;
	Image flechaR;
	Image man1;
	Image man2;
	

    //paramentros para calculos dos desenhos
    int roomsize;
    int wallsize;
    int doorsize;
    int arcrectsize1, arcrectsize2;
    int manscale;
    int arrowscale;
    int mansizex;
    int mansizey;


	//
	//Encontra qual eh o menor, a ou b.
	//
 	int min(int a, int b) {
      return ((a<b) ? a : b);
 	}
	
		
	public void init() {

		Panel interrogacao;
		Panel limite;
		Panel botoes;
		Panel panelpontuacao=new Panel();
//		Panel dificul = new Panel();
		Button restart = new Button("Restart");	
		stop = new Button("Stop");	

		Label l1;
		Label l2;
		removeAll();//remove todos os componentes do applet  
	    setLayout(new BorderLayout());
    			
		pp = new PanelDePintura();
		pp.addKeyListener(this);
		pp.addMouseListener(this);

		pontuacao= new TextField(4);
		pontuacao.setEditable(false);
		pontuacao.setBackground(Color.white);
		
		limiteSuperior = new TextField(4);
		limiteSuperior.setEditable(false);
		limiteSuperior.setBackground(Color.white);
		
		restart.setFont(new Font("Times New Roman",Font.PLAIN,12));
		restart.addActionListener(this); 
		stop.setFont(new Font("Times New Roman",Font.PLAIN,12));
		stop.addActionListener(this); 
		
		l1=new Label("      Pontuao:");
		l1.setFont(new Font("Times New Roman",Font.BOLD,12));
		
		l2=new Label("Limite Superior:");
		l2.setFont(new Font("Times New Roman",Font.BOLD,12));
		
		limite = new Panel( new FlowLayout());
		limite.add(l2);
		limite.add(limiteSuperior);
		
		panelpontuacao.setLayout(new BorderLayout());
		panelpontuacao.add("West",l1);
		panelpontuacao.add("Center",pontuacao);
		panelpontuacao.add("South",limite);

		interrogacao = new Panel();
		interrogacao.setLayout(new GridLayout(2,1));
		perigo=new CheckboxGroup();
		Checkbox perigowumpus = new Checkbox("Wumpus",perigo,true);
		Checkbox perigoabismo = new Checkbox("Abismo",perigo,true);
		interrogacao.add(perigowumpus);
		interrogacao.add(perigoabismo);
		
//		dificul.setLayout(new GridLayout(4,1));
//		Label l3 = new Label("Dificuldade");
//		l3.setFont(new Font("Times New Roman",Font.BOLD,12));
//		dificuldade=new CheckboxGroup();
//		Checkbox iniciante = new CheckBox("Iniciante",dificuldade,true);
//		Checkbox intermediario = new Checkbox("Intermedirio",dificuldade,true);
//		Checkbox avancado = new Checkbox("Avanado",dificuldade,true);
//		dificul.add(l3);
//		dificul.add(iniciante);
//		dificul.add(intermediario);
//		dificul.add(avancado);
		
		botoes = new Panel(new BorderLayout());
		botoes.add("Center",stop);
		botoes.add("South",restart);
		
		worldpanel = new Panel();
	    worldpanel.setLayout(new BorderLayout());
		worldpanel.add("Center",pp);
		
		menupanel = new Panel();
		menupanel.setLayout(new FlowLayout());
		menupanel.setBackground(Color.lightGray);
		menupanel.add(interrogacao);
		menupanel.add(botoes);
		menupanel.add(panelpontuacao);
//		menupanel.add(dificul);
/*		
		texto = new Panel();
		texto.setLayout(new BorderLayout());
		t1 = new TextArea(30,30);
		t1.setFont(new Font("Times New Roman", Font.BOLD,14));
		texto.add("Center",t1);
		
*/
		add("Center",worldpanel);
//		add("East",texto);
		add("South",menupanel);
	}

	public void start() 
	{
		URL url[];
		Dimension dim = getSize();//recebe as dimensoes do Applet		
		roomsize = min((dim.width-2)/NUMX,(dim.height-2)/NUMY);//calcula o tamanho de cada sala	
		url = new URL[1];//(getCodeBase(),"/agentes");
		url[0] = getCodeBase();
		
//		URLClassLoader urlClass = new URLClassLoader(url);//getCodeBase()+"/agentes"
//		Class agente = urlClass.findClass("AgenteBase");
				
		
			
		wumpus=getImage(getCodeBase(),"images/wumpus.gif");
		wumpusMorto=getImage(getCodeBase(),"images/wumpusMorto.gif");
		inter_verm=getImage(getCodeBase(),"images/interr_verm.gif");
		inter_verd=getImage(getCodeBase(),"images/interr_verd.gif");
		montanha=getImage(getCodeBase(),"images/montanha.gif");
		moedas=getImage(getCodeBase(),"images/moedas.gif");
		pegadas=getImage(getCodeBase(),"images/pegada.gif");
		flechaU=getImage(getCodeBase(),"images/flechaU.gif");
		flechaL=getImage(getCodeBase(),"images/flechaL.gif");
		flechaD=getImage(getCodeBase(),"images/flechaD.gif");
		flechaR=getImage(getCodeBase(),"images/flechaR.gif");
		
		wumpus = wumpus.getScaledInstance((int)3*roomsize/4,(int)3*roomsize/4,Image.SCALE_DEFAULT);
		wumpusMorto = wumpusMorto.getScaledInstance((int)3*roomsize/4,(int)3*roomsize/4,Image.SCALE_DEFAULT);
		inter_verm = inter_verm.getScaledInstance((int)3*roomsize/4,(int)3*roomsize/4,Image.SCALE_DEFAULT);
		inter_verd = inter_verd.getScaledInstance((int)3*roomsize/4,(int)3*roomsize/4,Image.SCALE_DEFAULT);
		montanha = montanha.getScaledInstance((int)3*roomsize/4,(int)3*roomsize/4,Image.SCALE_DEFAULT);
		moedas = moedas.getScaledInstance((int)3*roomsize/4,(int)3*roomsize/4,Image.SCALE_DEFAULT);
		pegadas = pegadas.getScaledInstance((int)3*roomsize/4,(int)3*roomsize/4,Image.SCALE_DEFAULT);
		flechaU = flechaU.getScaledInstance((int)3*roomsize/4,(int)3*roomsize/4,Image.SCALE_FAST);
		flechaL = flechaL.getScaledInstance((int)3*roomsize/4,(int)3*roomsize/4,Image.SCALE_DEFAULT);
		flechaD = flechaD.getScaledInstance((int)3*roomsize/4,(int)3*roomsize/4,Image.SCALE_DEFAULT);
		flechaR = flechaR.getScaledInstance((int)3*roomsize/4,(int)3*roomsize/4,Image.SCALE_DEFAULT);
		
	

		amb = new Ambiente(NUMX,NUMY,2,1,15,5,1,pp);
		
		
		
		//ag = new AgenteReativo();
		ag = new AgenteMapeadorArray();
		ag.setAmbiente(amb);
		ag.inicializaMundo();


		
		//bc.tell(ag);
	
		
		
		//ag = agente.newInstance();
		//ag.action();
		
		pontuacao.setText("        ");
		pontuacao.setText(""+amb.pegaPontuacao());
		limiteSuperior.setText("        ");
		limiteSuperior.setText(""+amb.calculaLimiteSuperior());

		if (agenteThread == null) {
            agenteThread = new Thread(this, "Agente");
            agenteThread.start();
        }

				
		System.out.println("Start finished");
		worldpanel.requestFocus();
		
	}
	
	public void stop()
	{
		agenteThread = null;
	}
	public void run() 
	{
		Thread myThread = Thread.currentThread();
		try 
   	    {
			agenteThread.sleep(1000);
	        while (agenteThread == myThread) 
			{
	   	        
	        	if (play){
					if(!amb.verificaGameover()){
						bc.tell(ag);
						bc.run();
						agenteThread.sleep(1000);
					}
	        	}
						//ag.action();
			}
   	    }catch (InterruptedException e)	        {
  	    	return;	// the VM doesn't want us to sleep anymore,
					            // so get back to work
	     }
	}
	
	//
	//Eventos de Teclado
	//	
	public void keyPressed(KeyEvent e)//trata o evento de teclado quando pressionamos uma tecla
	{
	}
	public void keyTyped(KeyEvent e)//trata o evento intermediario, entre o pressionar e o soltar
	{
	}
	public void keyReleased(KeyEvent e)//trata o evento quando uma tecla eh despressionada
	{
	}
	//
	//Eventos de Botao
	//
	public void actionPerformed(ActionEvent e)
	{
		String str = e.getActionCommand();
		if (str.equals("Restart"))
		{
			stop();	
			start();
			pp.repaint();
			pp.requestFocus();			
		}
		if (str.equals("Stop"))
		{
			play=!play;
			stop.setLabel("Play");
			pp.repaint();
			pp.requestFocus();			
		}
		if(str.equals("Play"))
		{
	 		play=!play;
			stop.setLabel("Stop");
			pp.repaint();
			pp.requestFocus();			
		}
	}
	
	public void mouseClicked(MouseEvent e)
	{
		int x,y;
		
		Checkbox cb = perigo.getSelectedCheckbox();
		
		Point p;
		p=e.getPoint();
		x=(int)p.x/roomsize;
		y=(int)p.y/roomsize;
		if("Wumpus".equals(cb.getLabel()))
			amb.setPerigoWumpus(x,y);
		else if("Abismo".equals(cb.getLabel()))
			amb.setPerigoAbismo(x,y);
		pp.repaint();	
	}
	public void mouseEntered(MouseEvent e)
	{
	}
	public void mouseExited(MouseEvent e)
	{
	}
	public void mousePressed(MouseEvent e)
	{
	}
	public void mouseReleased(MouseEvent e)
	{
	}
		


	public String getAppletInfo() {
		return "O Mundo do Wumpus, por Marlon G. Chermont";
	}
	
	
	
	//
	//
	//
	//Nova classe para o controle das pinturas
	//
	//
	//
	//
	class PanelDePintura extends Canvas
	{
	
		public PanelDePintura()
		{	
		}

		public void paint(Graphics g) 
		{
			int i, j;
			Dimension dim = getSize();//recebe es dimensoes do Applet		
			float ix, iy;
			
			g.clipRect(0,0,roomsize*NUMX+2,roomsize*NUMY+2);
			wallsize = (int)(roomsize*(1.0-DOOR_SIZE_PCT)/2.0);//determina o tamanho das paredes
			doorsize = roomsize-2*wallsize;//determina o tamanho das portas
			arcrectsize1 = 2*wallsize;
			arcrectsize2 = 2*(wallsize+doorsize);
			manscale = roomsize/2;//determina a escala do desenho
			arrowscale = roomsize/2;
			mansizey = manscale;//determina a escala em cada direcao do agente
			mansizex = 2*manscale/3;
			// pinta uma borda para evitar confusao
			g.setColor(BG_COLOR);
			g.fillRect(0,0,dim.width,dim.height);
			g.setColor(Color.black);
			g.drawRect(0,0,dim.width,dim.height);
			g.setColor(Color.orange);
			g.drawRect(0,0,roomsize*NUMX+1,roomsize*NUMY+1);
			for(i=0;i<NUMY;i++)
				for(j=0;j<NUMX;j++)
		    		drawRoom(g,j,i);
			drawMan(g);
			if (ag.verificaFireMode())
			{
				Point p = amb.pegaPosicao();
		  		drawFire(g,p.x,p.y);
			}
			pontuacao.setText(""+amb.pegaPontuacao());
			if(!amb.verificaGameover())
			 	showStatus(getAppletInfo());
			System.out.println("paint PP");	
		}
		//
		//
		//Este metodo eh responsavel por desenhar os quartos e suas devidas percepcoes
		//
		//	Entrada: g e a posicao do quarto
		//	Saida:   pinta na tela, as percepcoes e as paredes do quarto. Tambem eh responsavel
		//		     por pintar o wumpus, o abismo e a pepita de ouro
		//	Perigo:  nenhum
		//
		//
		void drawRoom(Graphics g, int x, int y)
		{
			int x1 = x*roomsize+1;
			int y1 = y*roomsize+1;
		
			g.setColor(Color.black);
		
			if (amb.verificaExpose(x,y))
			{
				//desenha as paredes do quarto
				g.drawArc(x1,y1,arcrectsize1,arcrectsize1,90,90);
    	        g.drawArc(x1+doorsize,y1,arcrectsize1,arcrectsize1,0,90);
        	    g.drawArc(x1,y1+doorsize,arcrectsize1,arcrectsize1,180,90);
            	g.drawArc(x1+doorsize,y1+doorsize,arcrectsize1,arcrectsize1,270,90);
				//desenha as portas dos quartos
    	        if (amb.verificaWallUp(x,y)) 
					g.drawLine(x1+wallsize,y1,x1+wallsize+doorsize,y1);
				if (amb.verificaWallLeft(x,y)) 
					g.drawLine(x1,y1+wallsize,x1,y1+wallsize+doorsize);
				if (amb.verificaWallDown(x,y)) 
					g.drawLine(x1+wallsize,y1+roomsize,x1+wallsize+doorsize,y1+roomsize);
				if (amb.verificaWallRight(x,y)) 
					g.drawLine(x1+roomsize,y1+wallsize,x1+roomsize,y1+wallsize+doorsize);	
				//desenha o WUMPUS	
				if(amb.verificaWumpus(x,y))
					g.drawImage(wumpus,x1+roomsize/8,y1+roomsize/8,this);
				//desenha o ABISMO
				if (amb.verificaAbismo(x,y))
				{
					g.setColor(Color.green);
					g.fillArc(x1+2,y1+2,roomsize-4,roomsize-4,0,360);
				}
				if (amb.verificaInicio(x,y))
					g.drawImage(montanha,x1+roomsize/8,y1+roomsize/8,this);	
				//desenha as brisa emitida pelo pit
				if (amb.buscaPercepcaoPit(x,y))
				{	
					g.setColor(Color.green);
					g.drawArc(x1+5,y1+5,roomsize-10,roomsize-10,0,360);
				}
				//desenha o rastro de sangue do WUMPUS
				if (amb.buscaPercepcaoWumpus(x,y))
					g.drawImage(pegadas,x1+roomsize/8,y1+roomsize/8,this);
				//desenha uma pepita de ouro
				if (amb.verificaOuro(x,y))
					g.drawImage(moedas,x1+roomsize/8,y1+roomsize/8,this);
				if (amb.verificaFlechada(x,y)&&amb.verificaExpose(x,y))
					g.drawImage(wumpusMorto,x1+roomsize/8,y1+roomsize/8,this);
			}
			else
			{
				if (amb.verificaFlechada(x,y)&&amb.verificaExpose(x,y))
					g.drawImage(wumpusMorto,x1+roomsize/8,y1+roomsize/8,this);
				else if(amb.verificaPerigoAbismo(x,y))
					g.drawImage(inter_verd,x1+roomsize/8,y1+roomsize/8,this);
				else if(amb.verificaPerigoWumpus(x,y))
					g.drawImage(inter_verm,x1+roomsize/8,y1+roomsize/8,this);

			}
		}
	
		//
		//
		//Este metodo eh responsavel por construir e pintar o agente na tela
		//
		//	Entrada: g, localizacao do agente (xp,yp) e em que escala ele deve ser desenhado (manscale)
		//	Saida:   o desenho do agente na tela
		//	Perigo:  nenhum
		//
		//
		void drawMan(Graphics g, int xp, int yp, float manscale) {
    		int xpts[] = new int[4];
		    int ypts[] = new int[4];
    		g.fillOval((int)(xp-manscale/6),(int)(yp-manscale/2),(int)(manscale/3),
	    	(int)(manscale/3));
	    	g.fillRect((int)(xp-manscale/3),(int)(yp-manscale/30),
    	   	(int)(2*manscale/3),(int)(manscale/15));
	    	g.fillRect((int)(xp-manscale/30),(int)(yp-manscale/6-1),
	    	(int)(manscale/15),(int)(manscale/3+2));
		    xpts[0] = (int)(xp-manscale/30);
    		xpts[1] = (int)(xp+manscale/30);
		    ypts[0] = ypts[1] = (int)(yp+manscale/6);
    		ypts[2] = ypts[3] = (int)(yp+manscale/2);
	    	xpts[2] = (int)(xpts[1]-manscale/3);
	    	xpts[3] = (int)(xpts[0]-manscale/3);
		    g.fillPolygon(xpts,ypts,4);
    		xpts[2] = (int)(xpts[1]+manscale/3);
		    xpts[3] = (int)(xpts[0]+manscale/3);
    		g.fillPolygon(xpts,ypts,4);
		}	
		//
		//
		//Este metodo localiza em que ponto o agente deve ser pintado, atualiza a sua cor
		//e chama o metodo drawMan para pinta-lo na tela
		//
		//	Entrada: g e a localizacao do agente na matriz
		//	Saida:   a posicao da tela onde o agente deve ser pintado
		//	Perigo:  nenhum
		//
		//
		void drawMan(Graphics g) 
		{
			int xp, yp;
			Point p=amb.pegaPosicao();
			xp = (2*p.x+1)*roomsize/2+1;
    	    yp = (2*p.y+1)*roomsize/2+1;
			g.setColor(ag.verificaFireMode() ? Color.magenta : Color.blue);
			drawMan(g,xp,yp,manscale);
		}
		//
		//
		//Este metodo desenha na tela a flecha atirada pelo	agente e retira uma de sua aljava
		//
		//			
		void drawFire(Graphics g,int x, int y)
		{
			int xpts[] = new int[4];
			int ypts[] = new int[4];
			int xp,yp;
	
			g.setColor(Color.black);

			if (amb.pegaNumFlechas()>=0)
			{
				switch (ag.pegaFireDir())	//descobre a direcao que foi disparada a flecha
				{
				case UP:
					if (!amb.verificaWallUp(x,y))	//verifica se existe algum muro a cima
					{
						g.drawImage(flechaU,(x*roomsize+roomsize/8),((y+NUMY-1)%NUMY)*roomsize+roomsize/8,this);
						amb.morteWumpus((int)x,(int)(y+NUMY-1)%NUMY);
				
					}else	//senao a flecha permanece em seu quarto
					{
						g.drawImage(flechaU,(x*roomsize+roomsize/8),y*roomsize+roomsize/8,this);
					}
					break;
				case LEFT:
					if (!amb.verificaWallLeft(x,y))	//verifica se existe algum muro a esquerda
					{
						g.drawImage(flechaL,((x+NUMX-1)%NUMX)*roomsize+roomsize/8,y*roomsize+roomsize/8,this);
						amb.morteWumpus((int)(x+NUMX-1)%NUMX,(int)y);
					}else	//senao a flecha permanece em seu quarto
					{
						g.drawImage(flechaL,x*roomsize+roomsize/8,y*roomsize+roomsize/8,this);
					}
					break;
				case DOWN:
					if (!amb.verificaWallDown(x,y))	//verifica se existe algum muro abaixo
					{
						g.drawImage(flechaD,x*roomsize+roomsize/8,((y+NUMY+1)%NUMY)*roomsize+roomsize/8,this);
						amb.morteWumpus((int)x,(int)(y+NUMY+1)%NUMY);
					}else	//senao a flecha permanece em seu quarto
					{
						g.drawImage(flechaD,x*roomsize+roomsize/8,y*roomsize+roomsize/8,this);	
					}
					break;
				case RIGHT:
					if (!amb.verificaWallRight(x,y))//verifica se existe algum muro a direita
					{
						g.drawImage(flechaR,((x+NUMX+1)%NUMX)*roomsize+roomsize/8,y*roomsize+roomsize/8,this);
						amb.morteWumpus((int)(x+NUMX+1)%NUMX,(int)y);
					}else	//senao a flecha permanece em seu quarto
					{
						g.drawImage(flechaR,x*roomsize+roomsize/8,y*roomsize+roomsize/8,this);
					}
					break;
				}
			}
		}
	}
}
