
       /////////////////////////////////////////////////////
      //                                                 //
     //      AgenteReativo.java                         //
    //     por Marlon G. Chermont(chermont@lsi.usp.br) //
   //     Criado: 09/11/2001						  //
  //	Ultima Alteracao: 23/11/2001                 //
 //                                                 //
/////////////////////////////////////////////////////

package agentes;
import java.awt.*;

import ambiente.AmbienteInterface;

public class AgenteReativo extends AgenteBase
{
	static final int PEGAROURO      = 1;
	static final int MOVER          = 1<<1;
	static final int ATIRARFLECHA   = 1<<2;
	static final int VOLTAR	    	= 1<<3;
	static final int SAIR			= 1<<4;
	

	//memoria primitiva
	static int ultimaDir;
	static boolean pegouOuro=false;
	static boolean atirouFlecha=false;

	static int DIR;
	
	Point p1 = new Point(); //passo atual
	Point p2 = new Point(); //passo da memoria
	
	
	public AgenteReativo()
	{
		super();
		ultimaDir=5;
		pegouOuro=false;
		atirouFlecha=false;
	}
	
	public void action()
	{
		int ACAO;
		if (verificaFireMode())
			setFireMode();
		else
		{
			
			ACAO = escolheAcao();
						
			switch (ACAO)
			{
				case PEGAROURO :
					pegaPepita();
					System.out.println("PEGAR OURO");
					break;
				case MOVER :
					
					ultimaDir = DIR;
					ocultar(p2);//oculta a sala visitada anteriormente que nao mais se encontra em sua memoria
					p2=p1.getLocation();//atualiza a a proxima posicao que deve ser apagada
					exibir(p1);//indica que este quarto ainda deve ser exibido, pois esta na sua memoria
					move(ultimaDir);
					p1=pegaPosicao();//pega a posicao atual do agente
					System.out.println("MOVER"+DIR);
					break;
				case ATIRARFLECHA :
					setFireMode();
					setFireDir(DIR);
					System.out.println("ATIRARFLECHA"+DIR);
					break;
				case VOLTAR :
					ultimaDir = (ultimaDir+2)%4;//assume a direcao contraria
					ocultar(p2);//oculta a sala visitada anteriormente que nao mais se encontra em sua memoria
					p2=p1.getLocation();//atualiza a a proxima posicao que deve ser apagada
					exibir(p1);//indica que este quarto ainda deve ser exibido, pois esta na sua memoria
					move(ultimaDir);
					p1=pegaPosicao();//pega a posicao atual do agente
					System.out.println("VOLTAR"+ultimaDir);
					break;
				case SAIR :
					voltaPraCasa();
					System.out.println("SAIR");
					break;
			}
		}
	}
	
	
	public int escolheAcao()
	{
		
		if (verificaOuro())
		{
			pegouOuro=true;
			return PEGAROURO;
		}
		if (atirouFlecha)		//se o agente atirou alguma flecha ele ira mover nesta mesma
		{						//direcao com a garantia de que este campo esta seguro 
			atirouFlecha=false;
			return MOVER;
		}		
		if (verificaWumpus())
		{
			if (verificaFlecha())	//verifica se o agente possui alguma flecha
			{
				DIR = (int)(Math.random()*4); //escolhe uma direcao
				atirouFlecha=true;
				return ATIRARFLECHA;
			}
			else
			{
				if (ultimaDir!=5) //verifica se ele ja fez alguma movimentacao 
					return VOLTAR;
				else
					return SAIR;
			}
		}
		if (verificaAbismo())
		{
			if (ultimaDir!=5) //verifica se ele ja fez alguma movimentacao 
				return VOLTAR;
			else
				return SAIR;
		}
		if (verificaInicio() && pegouOuro)
			return SAIR;
		do
		{
			DIR = (int)(Math.random()*4); //escolhe uma direcao 
		}while(verificaMuro(DIR));
		return MOVER;
	}
	
	private boolean verificaMuro(int dir)
	{
		switch (dir)
		{
			case AgenteBase.UP :
				return (verificaWallUp(p1.x,p1.y));
			case AgenteBase.DOWN:
				return (verificaWallDown(p1.x,p1.y));
			case AgenteBase.LEFT :
				return (verificaWallLeft(p1.x,p1.y));
			case AgenteBase.RIGHT :
				return (verificaWallRight(p1.x,p1.y));
		}
		return true;
	}
		
}
